'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
function VariableMix(theme) {
  var Core = theme.Core;
  var ComponentCustomStyle = theme.Checkbox;

  /**
   * 复选框
   * @namespace component
   * @property module checkbox
   * @property tag Checkbox
   * @property category component
   */

  var checkboxVaribles = {
    /**
     * size
     * @property namespace size/bounding
     */
    'medium-size-width': Core['s-6'],
    /**
     * size
     * @property namespace size/bounding
     */
    'medium-size-height': Core['s-6'],

    /**
     * size
     * @property namespace size/icon
     */
    'medium-icon-size': Core['icon-s'],
    /**
     * size
     * @property namespace size/icon
     */
    'medium-span-text': Core['icon-s'],
    /**
     * height
     * @property namespace size/bounding
     */
    'small-size-width': Core['s-5'],
    /**
     * height
     * @property namespace size/bounding
     */
    'small-size-height': Core['s-5'],
    /**
     * size
     * @property namespace size/icon
     */
    'small-icon-size': Core['icon-xs'],
    /**
     * size
     * @property namespace size/icon
     */
    'small-icon-text': Core['icon-xs'],

    /**
     * width
     * @property namespace size/border
     */
    'normal-border-width': Core['line-1'],
    /**
     * border
     * @property namespace statement/normal
     */
    'normal-border-color': Core['color-line1-3'],

    /**
     * border-style
     * @property namespace statement/normal
     */
    'normal-border-style': Core['line-solid'],

    /**
     * corner
     * @property namespace statement/normal
     */
    'small-border-radius': 999,
    /**
     * corner
     * @property namespace statement/normal
     */
    'medium-border-radius': 999,
    /**
     * background
     * @property namespace statement/normal
     */
    'normal-bg-color': Core['color-white'],
    /**
     * icon
     * @property namespace statement/selected
     */
    'normal-icon-color-selected': Core['color-white'],
    /**
     * border
     * @property namespace statement/selected
     */
    'normal-border-color-selected': Core['color-brand1-6'],
    /**
     * background
     * @property namespace statement/selected
     */
    'normal-bg-color-selected': Core['color-brand1-6'],

    /**
     * icon
     * @property namespace statement/disabled
     */
    'normal-icon-color-disabled': Core['color-text1-1'],

    /**
     * border
     * @property namespace statement/disabled
     */
    'normal-border-color-disabled': Core['color-line1-4'],
    /**
     * background
     * @property namespace statement/disabled
     */
    'normal-bg-color-disabled': Core['color-white'],
    /**
     * icon
     * @property namespace statement/disabled
     */
    'normal-icon-color-checked-disabled': Core['color-white'],
    /**
     * background
     * @property namespace statement/disabled
     */
    'normal-border-color-checked-disabled': Core['color-line1-4'],
    /**
     * background
     * @property namespace statement/disabled
     */
    'normal-bg-color-checked-disabled': Core['color-line1-4'],

    /**
     * icon
     * @property namespace statement/selected
     */
    'list-icon-color-selected': Core['color-brand1-6'],
    /**
     * icon
     * @property namespace statement/disabled
     */
    'list-icon-color-disabled': Core['color-text1-1'],
    /**
     * border
     * @property namespace statement/disabled
     */
    'list-border-color-disabled': Core['color-line1-2'],
    /**
     * background
     * @property namespace statement/disabled
     */
    'list-bg-color-disabled': Core['color-fill1-1'],
    /**
     * border
     * @property namespace size/border
     */
    'list-border-color': Core.transparent,
    /**
     * border-width
     * @property namespace size/border
     */
    'empty-border-width': Core['line-2'],
    /**
     * border
     * @property namespace statement/normal
     */
    'empty-border-color': Core['color-white'],
    /**
     * border-style
     * @property namespace statement/normal
     */
    'empty-border-style': Core['line-solid'],
    /**
     * corner
     * @property namespace statement/normal
     */
    'empty-border-radius': Core['corner-radius-circle'],
    /**
     * background
     * @property namespace statement/normal
     */
    'empty-bg-color': Core['color-black'],
    /**
     * icon
     * @property namespace statement/selected
     */
    'empty-icon-color-selected': Core['color-brand1-6'],
    /**
     * border
     * @property namespace statement/selected
     */
    'empty-border-color-selected': Core['color-brand1-6'],
    /**
     * background
     * @property namespace statement/selected
     */
    'empty-bg-color-selected': Core['color-brand1-6'],
    /**
     * icon
     * @property namespace statement/disabled
     */
    'empty-icon-color-disabled': Core['color-text1-1'],
    /**
     * border
     * @property namespace statement/disabled
     */
    'empty-border-color-disabled': Core['color-line1-2'],
    /**
     * background
     * @property namespace statement/disabled
     */
    'empty-bg-color-disabled': Core['color-fill1-1'],

    /**
     * width
     * @property namespace size/touch
     */
    'medium-touch-width': Core['s-11'],

    /**
     * height
     * @property namespace size/touch
     */
    'medium-touch-height': Core['s-11'],
    /**
     * width
     * @property namespace size/touch
     */
    'small-touch-width': Core['s-11'],
    /**
     * height
     * @property namespace size/touch
     */
    'small-touch-height': Core['s-11']
  };
  var variables = Object.assign(checkboxVaribles, ComponentCustomStyle);
  return variables;
}

exports.default = VariableMix;
module.exports = exports['default'];