/** @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeTouchable = require('nuke-touchable');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeThemeProvider = require('nuke-theme-provider');

var _checkbox = require('./checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function filterValue(selectedValue, value) {
  return selectedValue.filter(function (v) {
    return v !== value;
  });
}
/**
 * Checkbox.group
 */

var CheckboxGroup = function (_Component) {
  _inherits(CheckboxGroup, _Component);

  function CheckboxGroup(props) {
    _classCallCheck(this, CheckboxGroup);

    var _this = _possibleConstructorReturn(this, (CheckboxGroup.__proto__ || Object.getPrototypeOf(CheckboxGroup)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    _this.displayName = 'CheckboxGroup';
    return _this;
  }

  _createClass(CheckboxGroup, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        __group__: true,
        onChange: this.onChange,
        value: this.props.value
      };
    }
  }, {
    key: 'onChange',
    value: function onChange(value, checked) {
      var selectedValue = this.props.value;
      if (checked) {
        selectedValue = selectedValue.concat(value);
      } else {
        selectedValue = filterValue(selectedValue, value);
      }
      this.props.onChange && this.props.onChange(selectedValue);
    }
  }, {
    key: 'wrapPress',
    value: function wrapPress(value) {
      var checked = this.props.value.indexOf(value) === -1;
      this.onChange(value, checked);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = this.props.children;
      var _props = this.props,
          _props$dataSource = _props.dataSource,
          dataSource = _props$dataSource === undefined ? [] : _props$dataSource,
          style = _props.style,
          size = _props.size,
          themeStyle = _props.themeStyle,
          renderItem = _props.renderItem,
          groupItemStyle = _props.groupItemStyle,
          reverse = _props.reverse,
          labelStyle = _props.labelStyle;

      var groupStyle = Object.assign({}, themeStyle.group, groupItemStyle);

      var textStyle = Object.assign(size === 'small' ? themeStyle['group-small-text'] : themeStyle['group-medium-text'], labelStyle);

      if (!children) {
        children = dataSource.map(function (item, index) {
          if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) !== 'object') {
            item = { label: item, value: item, index: index };
          }

          var _item = item,
              label = _item.label,
              value = _item.value,
              disabled = _item.disabled,
              others = _objectWithoutProperties(_item, ['label', 'value', 'disabled']);

          if (label && !renderItem) {
            var labelGroup = [(0, _rax.createElement)(_checkbox2.default, {
              disabled: disabled,
              size: size,
              value: value,
              onChange: function onChange() {
                return _this2.onChange();
              }
            }), (0, _rax.createElement)(
              _nukeText2.default,
              { style: textStyle },
              label
            )];
            if (reverse) {
              labelGroup = labelGroup.reverse();
            }
            return (0, _rax.createElement)(
              _nukeTouchable2.default,
              {
                style: [groupStyle, style],
                onPress: function onPress() {
                  return _this2.wrapPress(value);
                }
              },
              labelGroup
            );
          } else if (label && renderItem) {
            return typeof renderItem === 'function' ? renderItem(item, _this2.onChange) : null;
          }
          return (0, _rax.createElement)(_checkbox2.default, _extends({}, others, { disabled: disabled, checked: value }));
        });
      }

      return (0, _rax.createElement)(
        _nukeView2.default,
        { style: style },
        children
      );
    }
  }]);

  return CheckboxGroup;
}(_rax.Component);

CheckboxGroup.displayName = 'CheckboxGroup';
CheckboxGroup.propTypes = {
  /**
   * 多选类型的数据源
   */
  dataSource: _rax.PropTypes.array,
  /**
   * 选择回调
   */
  onChange: _rax.PropTypes.func,
  /**
   * 选中value，配合dataSource的value字段使用
   */
  value: _rax.PropTypes.array,
  style: _rax.PropTypes.object,
  size: _rax.PropTypes.string,
  themeStyle: _rax.PropTypes.object,
  /**
   * 反转label与checkbox的显示顺序
   */
  reverse: _rax.PropTypes.bool,
  children: _rax.PropTypes.any,
  renderItem: _rax.PropTypes.func,
  /**
   * group子元素的外观样式
   */
  groupItemStyle: _rax.PropTypes.object,
  /**
   * group 子元素的label文案样式
   */
  labelStyle: _rax.PropTypes.object
};

CheckboxGroup.defaultProps = {
  dataSource: [],
  onChange: function onChange() {},
  value: [],
  style: {},
  size: 'small',
  themeStyle: {},
  reverse: false,
  groupItemStyle: {},
  labelStyle: {}
};
CheckboxGroup.childContextTypes = {
  onChange: _rax.PropTypes.func,
  __group__: _rax.PropTypes.bool,
  value: _rax.PropTypes.any
};
exports.default = (0, _nukeThemeProvider.connectStyle)(_styles2.default)(CheckboxGroup);
module.exports = exports['default'];